package org.kapelle.multiblock.constraint;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.util.BlockVector;
import org.kapelle.multiblock.MultiblockStructure;

import java.security.InvalidParameterException;
import java.util.List;

public class SameBlockConstraint implements IConstraint{

    private final List<BlockVector> positions;

    public SameBlockConstraint(List<BlockVector> positions){
        this.positions = positions;
        if (positions.size() <= 1){
            throw new InvalidParameterException("position need at least 2 positions");
        }
    }

    @Override
    public boolean isValid(Location coreBlockLocation, BlockVector offset, MultiblockStructure structure) {
        Material material = structure.getBlockLocation(coreBlockLocation,offset,positions.get(0)).getBlock().getType();

        for (BlockVector pos : positions) {
            if(structure.getBlockLocation(coreBlockLocation,offset,pos).getBlock().getType() != material){
                return false;
            }
        }

        return true;
    }
}
